from rocolib.api.components.Component import Component

c = Component()

c.addSubcomponent("front", "NewBrainsTwoWheels")
c.addSubcomponent("middle", "TwoWheels")
c.addSubcomponent("back", "TwoWheels", inherit=True, prefix=None)

# c.addConnection(("front", "sheath0.botedge2"), ("back", "sheath1.botedge2"))
# c.addConnection(("front", "sheath0.botedge0"), ("back", "sheath1.botedge0"), tabWidth=10)

c.addConstraint(("back", "length"), "length", "x+15")

#I'm trying to create a car with 6 wheels with the code below, but when I just use tabWidth. It wouldn't connect it in the 3D file
c.addConnection(("front", "sheath0.botedge2"), ("middle", "sheath1.botedge2"))
c.addConnection(("back", "sheath1.botedge2"), ("middle", "sheath1.topedge2"), tabWidth=20)
c.addConnection(("front", "sheath0.botedge0"), ("middle", "sheath1.botedge0"), tabWidth=20)
c.addConnection(("back", "sheath1.botedge0"), ("middle", "sheath1.topedge0"), tabWidth=20)

c.addSubcomponent("shield", "Rectangle")
c.addConstraint(("shield", "l"), ("driveservo", "height"), "x[1] - getDim(x[0],'motorwidth')")
c.addConstraint(("shield", "w"), "width")

c.addConnection(("shield", "b"), ("back", "splitedge0"), angle=90, tabWidth=10)
c.addConnection(("shield", "t"), ("back", "splitedge1"), angle=90)

c.toLibrary("FourWheelCar")